/*
 * CoverFinder - Find and download cover images from Amazon
 * Copyright (C) 2007 - 2008 - Sven Salzwedel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef _CF_APP
#define _CF_APP

#include <glib-object.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS

#define CF_TYPE_APP cf_app_get_type()

#define CF_APP(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST ((obj), CF_TYPE_APP, CfApp))

#define CF_APP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST ((klass), CF_TYPE_APP, CfAppClass))

#define CF_IS_APP(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CF_TYPE_APP))

#define CF_IS_APP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE ((klass), CF_TYPE_APP))

#define CF_APP_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_CLASS ((obj), CF_TYPE_APP, CfAppClass))

typedef enum
{
	CF_RESULT_COLUMN_IMG,
	CF_RESULT_COLUMN_DESCRIPTION,
	CF_RESULT_COLUMN_RESULT,
	CF_RESULT_COLUMN_NUM
} CfAppResultColumns;

typedef struct
{
	GObject parent;
	GtkBuilder *builder;
	GtkEntry *artist_entry;
	GtkEntry *title_entry;
	GtkEntry *keywords_entry;
	GtkComboBox *provider_combo;
	GtkTreeView *results_view;
	GtkProgressBar *progress_bar;
	GtkStatusbar *statusbar;
	gchar *statusbar_message;
	guint statusbar_default_ctx;
} CfApp;

typedef struct
{
	GObjectClass parent_class;
} CfAppClass;

GType cf_app_get_type (void);
void cf_app_show_window (CfApp *self);
void cf_app_quit (CfApp *self);
CfApp* cf_app_new (void);

G_END_DECLS

#endif /* _CF_APP */
